/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:23:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

/**
 * Recorded location of a worker.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class LocationRecord extends com.google.api.client.json.GenericJson {

  /**
   * The collection time in milliseconds since the epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long collectionTime;

  /**
   * The location accuracy in meters. This is the radius of a 95% confidence interval around the
   * location measurement.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double confidenceRadius;

  /**
   * Identifies this object as a location.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Latitude.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double latitude;

  /**
   * Longitude.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double longitude;

  /**
   * The collection time in milliseconds since the epoch.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCollectionTime() {
    return collectionTime;
  }

  /**
   * The collection time in milliseconds since the epoch.
   * @param collectionTime collectionTime or {@code null} for none
   */
  public LocationRecord setCollectionTime(java.lang.Long collectionTime) {
    this.collectionTime = collectionTime;
    return this;
  }

  /**
   * The location accuracy in meters. This is the radius of a 95% confidence interval around the
   * location measurement.
   * @return value or {@code null} for none
   */
  public java.lang.Double getConfidenceRadius() {
    return confidenceRadius;
  }

  /**
   * The location accuracy in meters. This is the radius of a 95% confidence interval around the
   * location measurement.
   * @param confidenceRadius confidenceRadius or {@code null} for none
   */
  public LocationRecord setConfidenceRadius(java.lang.Double confidenceRadius) {
    this.confidenceRadius = confidenceRadius;
    return this;
  }

  /**
   * Identifies this object as a location.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a location.
   * @param kind kind or {@code null} for none
   */
  public LocationRecord setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Latitude.
   * @return value or {@code null} for none
   */
  public java.lang.Double getLatitude() {
    return latitude;
  }

  /**
   * Latitude.
   * @param latitude latitude or {@code null} for none
   */
  public LocationRecord setLatitude(java.lang.Double latitude) {
    this.latitude = latitude;
    return this;
  }

  /**
   * Longitude.
   * @return value or {@code null} for none
   */
  public java.lang.Double getLongitude() {
    return longitude;
  }

  /**
   * Longitude.
   * @param longitude longitude or {@code null} for none
   */
  public LocationRecord setLongitude(java.lang.Double longitude) {
    this.longitude = longitude;
    return this;
  }

  @Override
  public LocationRecord set(String fieldName, Object value) {
    return (LocationRecord) super.set(fieldName, value);
  }

  @Override
  public LocationRecord clone() {
    return (LocationRecord) super.clone();
  }

}
