/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:23:15 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

/**
 * Job schedule.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Schedule extends com.google.api.client.json.GenericJson {

  /**
   * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
   * this is true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean allDay;

  /**
   * Job duration in milliseconds.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.math.BigInteger duration;

  /**
   * Scheduled end time in milliseconds since epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.math.BigInteger endTime;

  /**
   * Identifies this object as a job schedule.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Scheduled start time in milliseconds since epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.math.BigInteger startTime;

  /**
   * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
   * this is true.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getAllDay() {
    return allDay;
  }

  /**
   * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
   * this is true.
   * @param allDay allDay or {@code null} for none
   */
  public Schedule setAllDay(java.lang.Boolean allDay) {
    this.allDay = allDay;
    return this;
  }

  /**
   * Job duration in milliseconds.
   * @return value or {@code null} for none
   */
  public java.math.BigInteger getDuration() {
    return duration;
  }

  /**
   * Job duration in milliseconds.
   * @param duration duration or {@code null} for none
   */
  public Schedule setDuration(java.math.BigInteger duration) {
    this.duration = duration;
    return this;
  }

  /**
   * Scheduled end time in milliseconds since epoch.
   * @return value or {@code null} for none
   */
  public java.math.BigInteger getEndTime() {
    return endTime;
  }

  /**
   * Scheduled end time in milliseconds since epoch.
   * @param endTime endTime or {@code null} for none
   */
  public Schedule setEndTime(java.math.BigInteger endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * Identifies this object as a job schedule.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a job schedule.
   * @param kind kind or {@code null} for none
   */
  public Schedule setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Scheduled start time in milliseconds since epoch.
   * @return value or {@code null} for none
   */
  public java.math.BigInteger getStartTime() {
    return startTime;
  }

  /**
   * Scheduled start time in milliseconds since epoch.
   * @param startTime startTime or {@code null} for none
   */
  public Schedule setStartTime(java.math.BigInteger startTime) {
    this.startTime = startTime;
    return this;
  }

  @Override
  public Schedule set(String fieldName, Object value) {
    return (Schedule) super.set(fieldName, value);
  }

  @Override
  public Schedule clone() {
    return (Schedule) super.clone();
  }

}
